(***********************************************************************)
(*                              Project Couverture                     *)
(*                                                                     *)
(* file: coverUtils.ml                                                 *)
(* authors: Adrien Jonquet, Philippe Wang, Alexis Darrasse             *)
(* licence: CeCIL-B                                                    *)
(***********************************************************************)

let get_loc event =
  event.Covevent.covev_loc.Location.loc_start, event.Covevent.covev_loc.Location.loc_end

let get_fname event = event.Covevent.covev_loc.Location.loc_end.Lexing.pos_fname

let relocate_event orig event =
  event.Covevent.covev_pos <- orig + event.Covevent.covev_pos

let rec get_module_name ac ci_info =
  let res =
    try Some (input_line ci_info)
    with End_of_file -> None in
  match res with
  | Some s -> get_module_name (s :: ac) ci_info
  | None -> ac

let get_module_names () =
  let ci_info = open_in "cover.info" in
  let res = get_module_name [] ci_info in
  close_in ci_info;
  res
