(***********************************************************************)
(*                              Project Couverture                     *)
(*                                                                     *)
(* file: traceMcdc.ml                                                  *)
(* authors: Adrien Jonquet, Mathias Bourgoin, Philippe Wang            *)
(* licence: CeCIL-B                                                    *)
(***********************************************************************)


(* MC/DC vector type *)
type mcdc_bool = Bool of bool | Unknown

type condition =
    { mutable cond_value : mcdc_bool;
      mutable nb_cond : int;
      mutable cond : Covevent.coverage_event }

type decision =
    { mutable dec_value : mcdc_bool;
      mutable nb_dec : int;
      mutable dec : Covevent.coverage_event }

type vector_model =
    {   mutable mod_dec : Covevent.coverage_event;
        mutable mod_conds : Covevent.coverage_event list }

type vector =
    { mutable nb_vec : int;
      mutable vec_dec : decision;
      mutable vec_conds :  condition array}

type mcdc =
    { mutable model : vector_model;
      mutable vectors : vector list }
